"""

Datoteka sa ekstenzijom .json sadrze podatke o fudbalerima (ime, nacionalnost i broj golova) u sledecem formatu:

> [{"Ime": "Mika Mikic", "Nacionalnost": "nacija", "Golovi": 19}, ...]

Napisati program koji iz izabrane datoteke izdvaja fudbalere odredjene nacionalnosti i sortira ih rastuce po broju golova. Zeljena nacionalnost i ime datoteke se zadaju sa standardnog ulaza, a rezultat rada programa se upisuje u datoteku izabrana_nacionalnost.json.
"""

import json
linije = []
with open("/content/nacionalnosti.json", "r") as f:
  linije = f.readlines()

linije = [linija.strip() for linija in linije]
#linije_novo = []
#for linija in linije:
#  linije_novo.append(linija.strip())
print("".join(['a', 'b']))
linije_str = "".join(linije)
objekti = json.loads(linije_str)
print(objekti)
#for o in objekti:
#  print(o)
nacionalnost = input("Unesite nacionalnost:")
def golovi(objekat):
  return objekat['Golovi']
sortirani_objekti = sorted(objekti, key=golovi)
konacni_objekti = [o for o in sortirani_objekti if o['Nacionalnost']==nacionalnost]
#for o in sortirani_objekti:
#  if o['Nacionalnost'] == nacionalnost:
#    .append(o)
for o in konacni_objekti:
  print(o)

"""Kompanija Kompot ima 250 zaposlenih radnika. Rukovodstvo kompanije je odlucilo da svojim radnicima obezbedi dodatnu edukaciju. Da bi se radnik obucio programskom jeziku Go potrebno je platiti 100 evra po osobi za kurs, ali bi njegovo produktivno znanje ovog programskog jezika donelo 150 projekat/sati mesecno, sto bi za kompaniju znacilo dobit od 5 evra po projekat/satu. Da bi se radnik obucio programskom jeziku Ruby potrebno je platiti 105 evra po osobi, ali bi njegovo znanje ovog pj donelo 170 projekat/sati mesecno, koji bi za kompaniju znacili dobit od 6 evra po satu. Ukoliko Kompot ima na raspolaganju 26000 evra za obuku i maksimalan broj 51200 mogucih projekat/sati mesecno, odrediti na koji nacin kompanija treba da obuci svoje zaposlene kako bi se ostvarila maksimalna dobit.
> 170∗6∗max_r + 150∗5∗max_g − (100∗max_g + 150∗max_r)
"""

#!pip install python-constraint

import constraint
"""
250 radnika
Go:
100 evra po osobi kosta
150 p/s mesecno
5 evra dobit

Ruby:
105 evra po osobi kosta
170 p/s mesecno
6 evra dobit

ukupno 26000e za obuke
51200 p/s
"""
problem = constraint.Problem()
problem.addVariable("g", range(1, 251))
problem.addVariable("r", range(1, 251))

def ogranicenje_obuka(g, r):
  if 26000 >= 105*r + 100*g:
    return True

def ogranicenje_ps(g, r):
  if 51200 >= r*170 + g*150:
    return True

def ogranicenje_br_radnika(g, r):
  if g+r==250:
    return True

problem.addConstraint(ogranicenje_br_radnika, ['g', 'r'])
problem.addConstraint(ogranicenje_obuka, 'gr')
problem.addConstraint(ogranicenje_ps, "gr")

resenja = problem.getSolutions()
print(resenja)

max_g = -1
max_r = -1
for r in resenja:
  if 170*6*max_r + 150*5*max_g - (100*max_g + 150*max_r) < 170*6*r['r'] + 150*5*r['g'] - (100*r['g'] + 150*r['r']):
    max_g = r['g']
    max_r = r['r']

print("g:{0:d} r:{1:d}".format(max_g, max_r))

"""  Cistacica Mica sredjuje i cisti kuce i stanove. Da bi sredila i pocistila jedan stan potrebno joj je 1 sat, dok joj je za  kucu potrebno 1.5 sati. Prilikom ciscenja, Mica potrosi neku kolicinu deterdzenta, 120ml po stanu, odnosno 100ml po kuci. Mica zaradi 1000 dinara po svakom stanu, odnosno 1500 dinara po kuci. Ukoliko Mica radi 40 sati nedeljno i ima 5l deterdzenta na raspolaganju, koliko stanova i kuca je potrebno da ocisti kako bi imala najvecu zaradu?"""

problem = constraint.Problem()
"""
broj stanova koje je ocistila -> stan >0
broj kuca koje je ovistila -> kuca >0
40sati nedeljno, 5l deterdzenta

za 1 kucu potrosi 100ml i 1.5h
za 1 stan potrosi 120ml i 1h

stan*120 + kuca*100 <= 5*1000
stan*1 + kuca*1.5 <= 40

5000ml
stan 5000/120 => 42
kuca 5000/100 => 50

40h
stan 40/1 => 40
kuca 40/1.5 => 27
"""
problem.addVariable("kuca", range(1, 27))
problem.addVariable("stan", range(1, 41))

def ogranicenje_deterdzent(kuca, stan):
  if 120*stan + 100*kuca <= 5000:
    return True

def ogranicenje_sati(kuca, stan):
  if stan*1 + kuca*1.5 <= 40:
    return True

problem.addConstraint(ogranicenje_deterdzent, ['kuca', 'stan'])
problem.addConstraint(ogranicenje_sati, ["kuca", 'stan'])
resenja = problem.getSolutions()
print(resenja)

max_kuca = 0
max_stan = 0
for r in resenja:
  if 1000*r['stan'] + 1500*r['kuca'] > 1000*max_stan + 1500*max_kuca:
    max_stan = r['stan']
    max_kuca = r['kuca']

print("Maksimalna zarada {0:d}; broj kuca: {1:d}; broj stanova: {2:d}".format(1000*max_stan + 1500*max_kuca, max_kuca, max_stan))

